PRO PLOT_XSECT2, _EXTRA=extra, data, xlats, IP=ip, ZBOT=zbot, $
  ZTOP=ztop, TITLE=title, RANGE=range

z = DINDGEN(121)

IF N_ELEMENTS(zbot) EQ 0 THEN zbot = 0
IF N_ELEMENTS(ztop) EQ 0 THEN ztop = 80

map = TRANSPOSE(REFORM(data[zbot:ztop,ip]))

IF N_ELEMENTS(range) EQ 0 THEN $
  range = [MIN(map[WHERE(map NE -999)]), MAX(map)]

TVP, /MERGE, /SMOOTH, map, 1, 2, _EXTRA=extra, TITLE=title, $
  YTITLE='Altitude [km]', XRANGE=[MIN(ip), MAX(ip)], $
  YRANGE=[z[zbot], z[ztop]], XTICKS=0, RANGE=range, XSTYLE=5

lats = xlats[ip]
;lats = xlats[MIN(ip) + 6. * INDGEN((MAX(ip) - MIN(ip)) / 6.)]
;ticks = [-90., -75., -60., -45., -30., -15., 0., +15., +30., +45., +60., +75., +90.]
ticks = [-90., -75., -45., -15., +15., +45., +75., +90.]

sticks = STRTRIM(STRING(ticks, FORMAT='(I3)')) + ' '

nlats = N_ELEMENTS(lats)
f = 0.
name = ''
 
FOR i = 0, nlats - 2 DO BEGIN $
  q = WHERE((ticks - lats[i]) * (ticks - lats[i + 1]) LE 0.)
  IF q[0] NE -1 THEN BEGIN $
    f = [f, (FLOAT(i) + ABS((ticks[q[0]] - lats[i]) / $
      (lats[i] - lats[i + 1]))) / FLOAT(nlats)]
    name = [name, sticks[q[0]]]
  ENDIF
ENDFOR

IF N_ELEMENTS(F) LE 2 THEN BEGIN

  F = [0.0,0.01,0.99]
  Name = [' ', STRTRIM(STRING(Lats(0)),2), STRTRIM(STRING(Lats(NLats-1)),2) ]

ENDIF

f = f[1:*]
name = name[1:*]

AXIS, XAXIS=1, XRANGE=[0, 1], XTICKS=N_ELEMENTS(f) - 1, XTICKV=f, $
  XTICKNAME=REPLICATE(' ', N_ELEMENTS(f)), XTICKLEN=-0.001, $
  XTITLE='', charsize=1.
AXIS, XAXIS=0, XRANGE=[0, 1], XTICKS=N_ELEMENTS(f) - 1, XTICKV=f, $
  XTICKNAME=name, XTICKLEN=-0.015, XTITLE='Latitude', charsize=0.9

RETURN
END
