;; by Alyn Lambert

PRO PLOT_XSECTP,_EXTRA=EXTRA, DATA, xlats, ip=ip, PGrid, PBot=PBot, PTop=PTop, title=title, range=range

IF N_ELEMENTS(LOG) EQ 0 THEN LOG = 0
IF N_ELEMENTS(PBOT) EQ 0 THEN PBOT = 0
IF N_ELEMENTS(PTOP) EQ 0 THEN PTOP = 144
    
MAP = TRANSPOSE(REFORM(data[pbot:ptop,ip]))

IF N_ELEMENTS(RANGE) EQ 0 THEN $
  BEGIN
    RANGE = [MIN(MAP(WHERE( MAP NE -999 ))), MAX(MAP)]
ENDIF

TVPP,/MERGE, /SMOOTH,  MAP,1,2, _EXTRA=EXTRA, TITLE=title, ytitle='Pressure [hPa]',$
  XRANGE=[MIN(ip),MAX(ip)], YRANGE=[PGrid[PBot], PGrid[PTop]], XTICKS=0, $
  range=range, XSTYLE=5

lats = xlats(ip)
;lats = lat[MIN(IP) + 6.*INDGEN((MAX(ip)-MIN(ip))/6.)]
;ticks = [-90., -75., -60., -45., -30., -15., 0., +15., +30., +45., +60., +75., +90.]
ticks = [-90., -75., -45., -15., +15., +45., +75., +90]

sticks = STRTRIM(STRING(ticks, FORMAT='(I3)'))+' '

nlats = N_ELEMENTS(lats)
f = 0.
name = ''

FOR i = 0,nlats-2 DO $
  BEGIN
    q = WHERE( (ticks - lats(i)) * (ticks - lats(i+1)) LE 0. )
    IF q(0) NE -1 THEN $
      BEGIN
        f = [f, ( FLOAT(i) + ABS( (ticks(q[0]) - lats(i)) / (lats(i) - lats(i+1)) ) ) /FLOAT(nlats) ] 
        name = [name, sticks(q[0])]
    ENDIF
ENDFOR

IF N_ELEMENTS(F) LE 2 THEN BEGIN

  F = [0.0,0.01,0.99]
  Name = [' ', STRTRIM(STRING(Lats(0)),2), STRTRIM(STRING(Lats(NLats-1)),2) ]

ENDIF

f = f(1:*)
name = name(1:*)

AXIS, xaxis = 1, xrange=[0,1], xticks=N_ELEMENTS(f)-1, xtickv=f, xtickname=REPLICATE(' ',N_ELEMENTS(f)), xticklen=-0.001, xtitle='',charsize=1.0
AXIS, xaxis = 0, xrange=[0,1], xticks=N_ELEMENTS(f)-1, xtickv=f, xtickname=name, xticklen=-0.015, xtitle='Latitude', charsize=0.9

RETURN
END
