PRO TVPP, pimage, npx, npy,  x0,y0, scale = scale , range = range, $
         xrange = xrange, yrange = yrange, ptitle = ptitle, orient = orient, $
         levels = levels, wrap = wrap, $
         sample = sample, land = land, xticks = xticks, charsize = charsize, merge=merge, smooth=smooth, log10=log10, _EXTRA=EXTRA
; plots a pixel image with optional scale
IF (N_ELEMENTS(land) EQ 0) THEN land = 1
IF (N_ELEMENTS(merge) EQ 0) THEN merge = 0
IF (N_ELEMENTS(smooth) EQ 0) THEN smooth = 0
IF (N_ELEMENTS(log10) EQ 0) THEN log10 = 0
IF (N_ELEMENTS(ptitle) EQ 0) THEN ptitle = ''

IF !d.name EQ 'Xpseudocolor' THEN ncolours=!d.n_colors ELSE ncolours=256

IF (!d.name EQ 'PS') THEN $
  BEGIN
    CASE LAND OF
        0: DEVICE, /PORT,/INCH, xsize = 7.75, ysize = 10.75, xoffset=0.25, yoffset=0.25
        1: DEVICE, /LAND,/INCH, xsize = 10.5, ysize = 7.75, xoffset=0.25, yoffset=10.75
        ELSE:                   ; don't do set up if land not 0 or 1
    ENDCASE
    IF land EQ 0 OR land EQ 1 THEN COLOUR_PS, merge=merge
ENDIF

image = pimage
s = SIZE(image)
nx = s(1) & ny = s(2)
nsx = nx*npx & nsy = ny*npy
nfx = !d.x_size / nsx & nfy = !d.y_size / nsy

IF (N_ELEMENTS(npy) EQ 0) THEN npy = npx
IF (N_ELEMENTS(x0) EQ 0) THEN x0 = 150
IF (N_ELEMENTS(y0) EQ 0) THEN y0 = 100
IF N_ELEMENTS(scale) EQ 0 THEN scale = 0
IF N_ELEMENTS(wrap) EQ 0 THEN wrap = 0

IF (N_ELEMENTS(xrange) EQ 0) THEN $
  BEGIN
    IF (!x.range(1) - !x.range(0)) EQ 0 THEN xrange = [0,nx-1] ELSE xrange = !x.range
END

IF (N_ELEMENTS(yrange) EQ 0) THEN $
  BEGIN
    IF (!y.range(1) - !y.range(0)) EQ 0 THEN yrange = [0,ny-1] ELSE yrange = !y.range
END


IF (N_ELEMENTS(sample) EQ 0) THEN sample = 1

IF (N_ELEMENTS(xticks) EQ 0) THEN $
BEGIN
    xticks = !x.ticks 
END

IF (N_ELEMENTS(charsize) EQ 0) THEN charsize=1

IF xticks GT 20 then xticks = 0

IF log10 THEN image = ALOG10(image)   

CASE 1 OF
    !d.name EQ 'X' OR !d.name EQ 'Z' OR !d.name EQ 'WIN' : BEGIN

        CASE 1 OF

            xticks LT 0: PLOT, _EXTRA=EXTRA, xrange, yrange, $
              xtickname = REPLICATE(' ',2), $
              ytickname = REPLICATE(' ',2), $
              ticklen = 0, /nodata,  $
              xrange = xrange, yrange = yrange, $
              xstyle = 1, ystyle=1, xticks = 1, yticks = 1, /ylog

        ELSE:      PLOT, _EXTRA=EXTRA, xrange, yrange, $
          ticklen = -0.02, charsize=charsize, /nodata,  $
          xrange = xrange, yrange = yrange, $
          xstyle = 1, ystyle = 1, xticks = xticks, /ylog
          ENDCASE

; scale image to fit plot area
        dx = !P.CLIP(2) - !P.CLIP(0) - 1
        dy = !P.CLIP(3) - !P.CLIP(1) - 1

        image = RESIZE(image,dx,dy,wrap=wrap)

        IF (N_ELEMENTS(range) GT 0) THEN $
          BEGIN
            vmin = range(0) & vmax = range(1)
            IF log10 THEN $
              BEGIN
                vmin = ALOG10(vmin) & vmax = ALOG10(vmax)
            ENDIF   
            image = BYTSCL(image, MIN=vmin, MAX=vmax, TOP = ncolours-1)
        END ELSE $
          BEGIN
            vmin = MIN(image) & vmax = MAX(image)
            image = BYTSCL(image, MIN=vmin, MAX=vmax, TOP = ncolours-1)
        END

        TV,image, !P.CLIP(0)+1, !P.CLIP(1)+1

        IF scale THEN $
          BEGIN
            IF log10 THEN $
              BEGIN
                svmin = 10.^vmin & svmax = 10.^vmax & plog = 1
            END ELSE $
              BEGIN
                svmin = vmin & svmax = vmax & plog = 0
            END
            ;; save  image plot coords
            xsav = !X & ysav = !Y & psav = !P
            ;; calc posn for pixel scale
            nrows = 1 > !P.MULTI(1)
            rowsize = !D.X_SIZE / FLOAT(nrows)
            nrow = FIX(!P.CLIP(0)/rowsize)
            px = nrow * rowsize
            PIXEL_SCALE, _EXTRA=EXTRA, px,$
              !P.CLIP(1), charsize = charsize, $
              3*!d.x_ch_size, 0.5*(!P.CLIP(3)-!P.CLIP(1)), $
              svmin,svmax , ptitle, orient = orient, plog = plog
; reestablish image plot coords
            !X = xsav & !Y = ysav & !P = psav
        END
    END


    !d.name EQ 'PS': BEGIN

        CASE 1 OF

            xticks LT 0: PLOT, _EXTRA=EXTRA, xrange, yrange, $
              xtickname = REPLICATE(' ',2), $
              ytickname = REPLICATE(' ',2), $
              ticklen = 0, /nodata,  $
              xrange = xrange, yrange = yrange, $
              xstyle = 1, ystyle=1, xticks = 1, yticks = 1, /ylog


            ELSE:      PLOT, _EXTRA=EXTRA, xrange, yrange, $
              ticklen = -0.02, charsize=charsize, charthick=2, /nodata,  $
              xrange = xrange, yrange = yrange, $
              xstyle = 1, ystyle = 1, xticks = xticks, /ylog
        ENDCASE

        IF WRAP THEN image = RESIZE(image,nsx,nsy,wrap=wrap)

        IF smooth THEN $
          BEGIN
            image = RESIZE(image,nsx,nsy)
        ENDIF

        IF (N_ELEMENTS(range) GT 0) THEN $
          BEGIN
            vmin = range(0) & vmax = range(1)
            IF log10 THEN $
              BEGIN
                vmin = ALOG10(vmin) & vmax = ALOG10(vmax)
            ENDIF   
            image = BYTSCL(image, MIN=vmin, MAX=vmax, TOP = ncolours-1)
        END ELSE $
          BEGIN
            vmin = MIN(image) & vmax = MAX(image)
            image = BYTSCL(image, MIN=vmin, MAX=vmax, TOP = ncolours-1)
        END
        
;PS has scaleable pixels
        TV,image, !x.window(0), !y.window(0), $
          xsize = !x.window(1)-!x.window(0), $
          ysize = !y.window(1)-!y.window(0), /norm

        IF scale THEN $
          BEGIN
            IF log10 THEN $
              BEGIN
                svmin = 10.^vmin & svmax = 10.^vmax & plog = 1
            END ELSE $
              BEGIN
                svmin = vmin & svmax = vmax & plog = 0
            END
        ;; save  image plot coords
            xsav = !X & ysav = !Y & psav = !P
            nrows = 1 > !P.MULTI(1)
            rowsize = !D.X_SIZE / FLOAT(nrows)
            nrow = FIX(!P.CLIP(0)/rowsize)
            px = nrow * rowsize
            px = CONVERT_COORD(px,0,0,/device,/to_norm)
            cw = CONVERT_COORD(3*!d.x_ch_size,0,0,/device,/to_norm)

            PIXEL_SCALE, px(0), $
              !y.window(0), charsize = charsize, $
              cw(0), 0.5*(!y.window(1)-!y.window(0)), $
              svmin,svmax , ptitle, orient = orient, plog = plog
; reestablish image plot coords
            !X = xsav & !Y = ysav & !P = psav
        END
    END
    ELSE:print, !d.name + 'Not Supported'
ENDCASE
RETURN
END









